{-|
Module      : Gargantext.API.Worker
Description : New-style Worker API (no more servant-job)
Copyright   : (c) CNRS, 2024-Present
License     : AGPL + CECILL v3
Maintainer  : team@gargantext.org
Stability   : experimental
Portability : POSIX

-}

{-# LANGUAGE TypeOperators #-}

module Gargantext.API.Worker where

import Gargantext.API.Prelude (IsGargServer)
import Gargantext.Core.Worker.Jobs (sendJob)
import Gargantext.Core.Worker.Jobs.Types (Job(..))
import Gargantext.Core.Worker.Types
import Gargantext.Prelude
import Servant.API ((:>), (:-), JSON, Post, ReqBody)
import Servant.Server.Generic (AsServerT)


data WorkerAPI input mode = WorkerAPI
  { workerAPIPost :: mode :- ReqBody '[JSON] input
                          :> Post '[JSON] JobInfo }
  deriving Generic


-- serveWorkerAPI :: ( HasWorkerBroker PGMQBroker Job
--                   , m ~ GargM Env BackendInternalError )
--                => (input -> Job)
--                -> input
--                -> WorkerJob (AsServerT m)
--                -- -> ServerT (Post '[JSON] JobInfo) m
--                -- -> Cmd' env err JobInfo
-- serveWorkerAPI f i = do
--   mId <- sendJob $ f i
--   pure $ JobInfo { _ji_message_id = mId }

serveWorkerAPI :: IsGargServer env err m
              => (input -> Job)
              -> WorkerAPI input (AsServerT m)
serveWorkerAPI f = WorkerAPI { workerAPIPost }
  where
    workerAPIPost i = do
      mId <- sendJob $ f i
      pure $ JobInfo { _ji_message_id = mId }
