{-|
Module      : Gargantext.Core.Worker.Types
Description : Some useful worker types
Copyright   : (c) CNRS, 2024-Present
License     : AGPL + CECILL v3
Maintainer  : team@gargantext.org
Stability   : experimental
Portability : POSIX

-}

module Gargantext.Core.Worker.Types where

import Async.Worker.Broker.PGMQ (PGMQBroker)
import Async.Worker.Broker.Types qualified as BT
import Data.Aeson ((.=), (.:), object, withObject)
import Data.Swagger (NamedSchema(..), ToSchema(..))  -- , genericDeclareNamedSchema)
import Gargantext.Prelude



data JobInfo = JobInfo { _ji_message_id :: !(BT.MessageId PGMQBroker) }
  deriving (Show, Eq, Ord, Generic)
instance ToSchema JobInfo where -- TODO
  --declareNamedSchema = genericDeclareNamedSchema (unPrefixSwagger "_ji_")
  declareNamedSchema _ = do
    return $ NamedSchema (Just "JobInfo") $ mempty
instance FromJSON JobInfo where
  parseJSON = withObject "JobInfo" $ \o -> do
    _ji_message_id <- o .: "message_id"
    pure $ JobInfo { .. }
instance ToJSON JobInfo where
  toJSON (JobInfo { .. }) = object [ ("message_id" .= _ji_message_id )]

